const exec = require("util").promisify(require("child_process").exec);
const { connectApi, getCouncils } = require("./lib/api");

const providerUrl = `ws://localhost:9944`;
const script = `./build/update-reports.sh`;

const updateReports = async () => {
  console.debug(`Connecting to ${providerUrl}`);
  const api = await connectApi(providerUrl);
  await api.isReady;

  console.log(`Fetching councils`);
  const head = await api.derive.chain.bestNumberFinalized();
  const councils = await getCouncils(api, head);
  api.disconnect();

  console.log(`Updating ${script}`);
  const commands: string[] = [];
  for (let council of councils) {
    const { round, start, end } = council;
    const filename = `Council_Round_${round}_${start}-${end}.md`;
    commands.push(`node ./build/generator.js ${start} ${end}`);
    commands.push(`cp report.md ${filename}`);
  }
  require("fs").writeFileSync(script, commands.join(`\n`));
};
updateReports();
